<template>
  <v-row class="model" no-gutters>
    <v-col class="alignVertical hokenBackground" cols="12" sm="12" md="6" lg="6" xl="6">
      <v-row no-gutters justify="center">
        <v-col cols="12" align="center" class="polvoFont mb-0">
          <span style="font-size: 3.3rem">Polvo</span>
        </v-col>
        <v-col cols="12" align="center" class="my-2">
          <img src="../assets/animated2.gif" class="logoHokenSize" />
        </v-col>
        <v-col cols="12" align="center" class="mt-4">
          <span style="font-size: 1rem">
            Olá visitanteeeeeeeeeeeeeee, seja bem-vindo ao sistema qa
            <span class="test--text">UDESC</span> | Polvo
          </span>
        </v-col>
      </v-row>
    </v-col>
    <v-col class="alignVertical" cols="12" sm="12" md="6" lg="6" xl="6">
      <div style="display:block; width: 100%">
        <v-row no-gutters justify="center" class="mb-8">
          <span class="primary--text" style="font-size:2rem"><b>Login</b></span>
        </v-row>
        <v-row no-gutters justify="center" class="mb-3">
          <v-text-field
            style="max-width: 70%"
            v-model="polvo.form.email"
            prepend-icon="mdi-account"
            name="login"
            type="text"
            @keyup.enter="login"
          />
        </v-row>
        <v-row no-gutters justify="center" class="mb-8">
          <v-text-field
            style="max-width: 70%"
            id="password"
            v-model="polvo.form.password"
            prepend-icon="mdi-lock"
            name="password"
            label="Senha"
            :type="showPassword ? 'text' : 'password'"
            :append-icon="showPassword ? 'mdi-eye' : 'mdi-eye-off'"
            @click:append="showPassword = !showPassword"
            @keyup.enter="handleSystemLogin"
            @click="validate_login = false"
          >
          </v-text-field>
        </v-row>
        <v-row no-gutters justify="center">
          <v-btn elevation="0" color="primary" @click="handleSystemLogin">
            {{ $vuetify.lang.t('$vuetify.login.options.enter') }}
          </v-btn>
        </v-row>
      </div>
    </v-col>
  </v-row>
  <!-- <v-container fluid fill-height class="body">
    <v-row class="green">rsrsrs</v-row>
    <v-row justify="center" align="center">
      <img src="../assets/logo-kraken.png" />
      <div class="headerDivider"></div>
      <v-col cols="10" md="4">
        <v-row no-gutters>
          <v-col align="center" @click="handleIdLogin">
            <v-btn block text class="white--text" @click="loginMethod = 'Polvo'">
              LOGIN Polvo
            </v-btn>
          </v-col>
        </v-row>
        <v-divider dark class="mb-6" />
        <v-form v-if="loginMethod === 'Polvo'">
          <v-text-field
            v-model="polvo.form.email"
            prepend-icon="mdi-account"
            name="login"
            label="E-mail, matrícula ou CPF (ou Passaporte para estrangeiros sem CPF)"
            type="text"
            dark
            @keyup.enter="login"
          >
          </v-text-field>
          <v-text-field
            id="password"
            v-model="polvo.form.password"
            prepend-icon="mdi-lock"
            name="password"
            label="Senha"
            type="password"
            dark
            @keyup.enter="handleSystemLogin"
            @click="validate_login = false"
          >
          </v-text-field>
        </v-form>
        <v-form v-if="loginMethod === 'ID'">
          <v-text-field
            v-model="login.form.email"
            prepend-icon="mdi-account"
            name="login"
            label="CPF"
            type="text"
            dark
            @keyup.enter="login"
          >
          </v-text-field>
          <v-text-field
            id="password"
            v-model="login.form.password"
            prepend-icon="mdi-lock"
            name="password"
            label="Senha"
            type="password"
            dark
            @keyup.enter="handleSystemLogin"
            @click="validate_login = false"
          >
          </v-text-field>
        </v-form>
        <v-flex xs12 offset-md9 offset-lg10>
          <v-btn dark text class="warning--text" @click="handleSystemLogin">
            {{ $vuetify.lang.t('$vuetify.login.options.enter') }}
          </v-btn>
        </v-flex>
      </v-col>
    </v-row>
  </v-container> -->
</template>

<script>
import Open from '../services/open'
import User from '../services/user'
import { mapMutations } from 'vuex'

export default {
  name: 'Login',
  components: {},
  data: () => ({
    showPassword: false,
    loginMethod: 'Polvo',
    polvo: {
      form: {
        email: '',
        documentNumber: '37598874816',
        password: '',
      },
      show1: false,
      polvoFormValid: '',
    },
    login: {
      form: {
        id: '',
        password: '',
      },
      showPassword: false,
      loginFormValid: '',
    },
  }),
  methods: {
    ...mapMutations('user', [
      'DO_LOGIN',
      'UPDATE_LOGGED',
      'UPDATE_TOOLBAR_ENTITIES',
      'UPDATE_ROOT_ENTITIES',
    ]),
    keyMethod(event) {
      if (event.key === 'Enter') this.handleIdLogin()
    },
    async handleSystemLogin() {
      try {
        this.$store.commit('user/UPDATE_LOADING', true)
        let ret = await Open.logIn(this.polvo.form)
        if (ret.success && ret.data) {
          await this.$setItem('userInfo', ret.data)
          await this.$setItem('accessKey', ret.data.accessKey)
          await this.$setItem('logged', true)
          await sessionStorage.setItem('logged', true)
          await this.readEntities()
          await this.readToolbarEntities()
          await this.UPDATE_LOGGED(true)
          await this.DO_LOGIN(ret.data.user)
          this.menu = false
          await this.$router.push('/home').catch((err) => {})
        } else {
          if (ret.data.description.indexOf('emailOrPasswordInvalid') > -1) {
            this.$store.commit('user/UPDATE_ALERT', {
              status: true,
              message: 'Atenção, login e/ou senha estão <b>incorretos</b>. <br>Tente novamente.',
              icon: 'mdi-alert',
              color: 'warning',
            })
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
    },
    async handleIdLogin() {},
    async readEntities() {
      try {
        let ret = await User.readUserEntities()
        console.log('Retorna entidades que o usuario está participando', ret)
        if (ret.success) {
          await this.$setItem('rootEntities', ret.data)
          this.UPDATE_ROOT_ENTITIES(ret.data)
        }
      } catch (e) {
        console.log('e', e)
      }
    },
    async readEntityChild(id) {
      let child
      try {
        let ret = await User.readEntityChild(id)
        if (ret.success) {
          child = ret.data
        }
      } catch (e) {
        console.log(e)
      }
      return child
    },
    async readToolbarEntities() {
      const rootEntities = await this.$getItem('rootEntities')
      let entities = []
      rootEntities &&
        rootEntities.forEach((el) => {
          let entityObject = {
            id: el.id,
            title: el.name,
          }
          entities.push(entityObject)
        })
      this.UPDATE_TOOLBAR_ENTITIES(entities)
      await this.$setItem('toolbarEntities', entities)
    },
  },
}
</script>

<style lang="scss" scoped>
.model {
  height: 100%;
}

.logoHokenSize {
  max-width: 35%;
  min-width: 230px;
}

.alignVertical {
  display: flex;
  align-items: center;
  justify-content: center;
}

.hokenBackground {
  background: #1f0735;
  color: white;
}

// CSS template antigo

.is-danger {
  color: #ff5252;
  font-size: 12px;
}

.input_login {
  color: white !important;
}

.headerDivider {
  border-left: 1px solid white;
  border-right: 1px solid white;
  height: 200px;
  margin-right: 50px;
}

.display-logo-mobile {
  display: none;
}

/**
  Layout mobile.
   */
@media screen and (max-width: 767px) {
  .headerDivider {
    display: none;
  }
  .display-logo {
    display: none;
  }
  .display-logo-mobile {
    display: inline-flex;
    max-height: 200px;
    max-width: 187px;
  }
  .layout-mobile {
    margin-top: 40%;
    text-align: center !important;
    align-items: flex-start;
  }

  .header-mobile {
    text-align: left !important;
  }
}
/***/

.body {
  width: 100%;
  height: 100%;
  color: #fff;
  background: linear-gradient(-45deg, #9b64ff, #4d3582, #2a0845, #1f0735) !important;
  background-size: 400% 400% !important;
  -entrarwebkit-animation: Gradient 15s ease infinite;
  -moz-animation: Gradient 15s ease infinite;
  animation: Gradient 15s ease infinite;
}

@-webkit-keyframes Gradient {
  0% {
    background-position: 0% 50%;
  }
  50% {
    background-position: 100% 50%;
  }
  100% {
    background-position: 0% 50%;
  }
}

@-moz-keyframes Gradient {
  0% {
    background-position: 0% 50%;
  }
  50% {
    background-position: 100% 50%;
  }
  100% {
    background-position: 0% 50%;
  }
}

@keyframes Gradient {
  0% {
    background-position: 0% 50%;
  }
  50% {
    background-position: 100% 50%;
  }
  100% {
    background-position: 0% 50%;
  }
}

h1,
h6 {
  font-family: 'Open Sans';
  font-weight: 300;
  text-align: center;
  position: absolute;
  top: 45%;
  right: 0;
  left: 0;
}
</style>
